//========================================================================
//  Program: IDEA_ScheduleWeekly.java
//
// Author:  F2-Team2
// This is a program written for the UIT2201 Project
//
// This program takes input a person's id and date in ddmmyyyy format
// output: activities for the week if there is at least 1, else will print out just the dates.
//
//
package IDEA_Schedule;
import java.sql.*;   // LHW: this imports sql related classes
import java.util.*;
import DBClasses.*;  // LHW: imports database manager and other classes


class IDEA_Weekly_Schedule {

	public static void main(String[] args ) {
		try
		{
		  String pers_id = args[0];
		  String date = args[1];
		  String day = date.substring(0,2);
		  String mth = date.substring(2,4);
		  String year = date.substring(4,8);
		  GregorianCalendar startOfWeek = new GregorianCalendar(Integer.parseInt(year),Integer.parseInt(mth)-1,Integer.parseInt(day));
		  int num = startOfWeek.get(Calendar.DAY_OF_WEEK) - 1;
		  startOfWeek.add(startOfWeek.DATE, -num);

		for (int i = 0; i <7 ; i++)
		{

		  day = Integer.toString(startOfWeek.get(GregorianCalendar.DATE));
		  mth = Integer.toString(startOfWeek.get(GregorianCalendar.MONTH)+1);
		  year = Integer.toString(startOfWeek.get(GregorianCalendar.YEAR));

		  if (mth.length() == 1)
		  {
			  mth = "0" + mth;
		  }

		  date = day+mth+year;


		  printDaily(pers_id,date);
		  startOfWeek.add(startOfWeek.DATE, 1);
		 }
		}//end try

		catch (Exception e) {
		      //System.out.println("DB Error!"); // error message if exception occurs
		      //e.printStackTrace();
		      System.out.println("No Activity");
    	}

	}

  	static void printDaily(String pers_id, String date) {


     // LHW: Create a database connection
     // LHW:  by using the dbManager class provided
     dbManager dbman = new dbManager();
     Connection conn = dbman.getConnection();

     String day = date.substring(0,2);
     String mth = date.substring(2,4);
     String year = date.substring(4,8);

     //GregorianCalendar today = new GregorianCalendar(Integer.parseInt(year),Integer.parseInt(mth),Integer.parseInt(day));
     GregorianCalendar tomorrow = new GregorianCalendar(Integer.parseInt(year),Integer.parseInt(mth)-1,Integer.parseInt(day));
	 tomorrow.add(tomorrow.DATE, 1);

	 mth = convert(mth);
	 String sDate = day + "-" + mth + "-" + year;

	 day = Integer.toString(tomorrow.get(GregorianCalendar.DATE));
	 mth = Integer.toString(tomorrow.get(GregorianCalendar.MONTH)+1);
	 mth = convert(mth);
	 year = Integer.toString(tomorrow.get(GregorianCalendar.YEAR));


     String tmrDate = day + "-" + mth + "-" + year;

     try {
       // To execute query,
       //   first create the sql statement
       //   execute the statement
       //   "catch" the output in "rs" (rs is a set of tuples)
       Statement stmt = conn.createStatement();
       String sql = "SELECT sch_id,sch_start,sch_end,sch_activity,sch_notes FROM Schedule WHERE sch_from_id = '"+pers_id+"' AND sch_start > '"+sDate+"' AND sch_end < '"+tmrDate+"' ORDER BY sch_start ASC";

            // prepare sql stmt
       ResultSet rs = stmt.executeQuery(sql);          // execute query



       System.out.println("Date : " + date);



       while (rs.next()) {                             // process the result

		String start = rs.getString("sch_start");
		start=start.substring(11,start.length()-1);
		String end = rs.getString("sch_end");
		end=end.substring(11,end.length()-1);
		String activity = rs.getString("sch_activity");
        String sch_id = rs.getString("sch_id");
       	System.out.println(sch_id + " " + start + "-" + end + " : " + activity );

       }



       rs.close();       // close everything (rs, stmt, conn)
       stmt.close();
       conn.close();
    } catch (Exception e) {
      //System.out.println("DB Error!"); // error message if exception occurs
      //e.printStackTrace();
      System.out.println("No Activity");
    }

  }

  static String convert (String mon)
    {
  	  if (mon.equals("01")||mon.equals("1"))
  	  {
  	  	mon = "Jan";
  	  }
  	  else if (mon.equals("02")||mon.equals("2"))
  	  {
  	  	mon = "Feb";
  	  }
  	  else if (mon.equals("03")||mon.equals("3"))
  	  {
  	  	mon = "Mar";
  	  }
  	  else if (mon.equals("04")||mon.equals("4"))
  	  {
  	  	mon = "Apr";
  	  }
  	  else if (mon.equals("05")||mon.equals("5"))
  	  {
  	  	mon = "May";
  	  }
  	  else if (mon.equals("06")||mon.equals("6"))
  	  {
  	  	mon = "Jun";
  	  }
  	  else if (mon.equals("07")||mon.equals("7"))
  	  {
  	  	mon = "Jul";
  	  }
  	  else if (mon.equals("08")||mon.equals("8"))
  	  {
  	  	mon = "Aug";
  	  }
  	  else if (mon.equals("09")||mon.equals("9"))
  	  {
  	  	mon = "Sep";
  	  }
  	  else if (mon.equals("10"))
  	  {
  	  	mon = "Oct";
  	  }
  	  else if (mon.equals("11"))
  	  {
  	  	mon = "Nov";
  	  }
  	  else if (mon.equals("12"))
  	  {
  	  	mon = "Dec";
  	  }

  	  return mon;
    }
}